## ros2-rcutils 5.2.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(rcutils)

# Default to C11
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()
# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

include(CheckLibraryExists)

find_package(ament_cmake_python REQUIRED)
find_package(ament_cmake_ros REQUIRED)

find_package(Python3 REQUIRED COMPONENTS Interpreter)

ament_python_install_package(${PROJECT_NAME})

if(UNIX AND NOT APPLE)
  include(cmake/check_c_compiler_uses_glibc.cmake)
  check_c_compiler_uses_glibc(USES_GLIBC)
  if(USES_GLIBC)
    # Ensure GNU extended libc API is used, as C++ test code will.
    # See https://gcc.gnu.org/bugzilla/show_bug.cgi?id=2082.
    add_definitions(-D_GNU_SOURCE)
  endif()
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  # enables building a static library but later link it into a dynamic library
  add_compile_options(-fPIC)
endif()
if(NOT WIN32)
  # About -Wno-sign-conversion: With Clang, -Wconversion implies -Wsign-conversion. There are a number of
  # implicit sign conversions in gtest.cc, see https://ci.ros2.org/job/ci_osx/9381/clang/.
  # Hence disabling -Wsign-conversion for now until all those have eventually been fixed.
  # (from https://github.com/ros2/rcutils/pull/263#issuecomment-663252537)
  add_compile_options(-Wall -Wextra -Wconversion -Wno-sign-conversion -Wpedantic)
endif()

if(WIN32)
  set(time_impl_c src/time_win32.c)
else()
  set(time_impl_c src/time_unix.c)
endif()

set(rcutils_sources
  src/allocator.c
  src/array_list.c
  src/char_array.c
  src/cmdline_parser.c
  src/env.c
  src/error_handling.c
  src/filesystem.c
  src/find.c
  src/format_string.c
  src/hash_map.c
  src/logging.c
  src/process.c
  src/qsort.c
  src/repl_str.c
  src/shared_library.c
  src/snprintf.c
  src/split.c
  src/strcasecmp.c
  src/strdup.c
  src/strerror.c
  src/string_array.c
  src/string_map.c
  src/testing/fault_injection.c
  src/time.c
  ${time_impl_c}
  src/uint8_array.c
)
set_source_files_properties(
  ${rcutils_sources}
  PROPERTIES language "C")

# "watch" template/inputs for changes
configure_file(
  "resource/logging_macros.h.em"
  "logging_macros.h.em.watch"
  COPYONLY)
configure_file(
  "rcutils/logging.py"
  "logging.py.watch"
  COPYONLY)
# generate header with logging macros
set(rcutils_module_path ${CMAKE_CURRENT_SOURCE_DIR})
set(python_code
  "import em"  # implicitly added ; between python statements due to CMake list
  "\
em.invoke( \
  [ \
    '-o', 'include/rcutils/logging_macros.h', \
    '-D', 'rcutils_module_path=\"${rcutils_module_path}\"', \
    '${CMAKE_CURRENT_SOURCE_DIR}/resource/logging_macros.h.em' \
  ] \
)")
string(REPLACE ";" "$<SEMICOLON>" python_code "${python_code}")
add_custom_command(OUTPUT include/rcutils/logging_macros.h
  COMMAND ${CMAKE_COMMAND} -E make_directory "include/rcutils"
  COMMAND Python3::Interpreter ARGS -c "${python_code}"
  DEPENDS
    "${CMAKE_CURRENT_BINARY_DIR}/logging_macros.h.em.watch"
    "${CMAKE_CURRENT_BINARY_DIR}/logging.py.watch"
  COMMENT "Expanding logging_macros.h.em"
  VERBATIM
)
list(APPEND rcutils_sources
  include/rcutils/logging_macros.h)

add_library(
  ${PROJECT_NAME}
  ${rcutils_sources})
target_include_directories(${PROJECT_NAME} PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/include>"
  "$<INSTALL_INTERFACE:include/${PROJECT_NAME}>")

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(${PROJECT_NAME} PRIVATE "RCUTILS_BUILDING_DLL")

if(BUILD_TESTING AND NOT RCUTILS_DISABLE_FAULT_INJECTION)
  target_compile_definitions(${PROJECT_NAME} PUBLIC RCUTILS_ENABLE_FAULT_INJECTION)
endif()

target_link_libraries(${PROJECT_NAME} ${CMAKE_DL_LIBS})

# Needed if pthread is used for thread local storage.
if(IOS AND IOS_SDK_VERSION LESS 10.0)
  ament_export_libraries(pthread)
endif()

install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

if(BUILD_TESTING)
  if(NOT WIN32)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
  endif()

  find_package(performance_test_fixture REQUIRED)

  find_package(ament_cmake_gmock REQUIRED)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(ament_cmake_pytest REQUIRED)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  find_package(launch_testing_ament_cmake REQUIRED)

  check_library_exists(atomic __atomic_load_8 "" HAVE_LIBATOMICS)

  if(HAVE_LIBATOMICS AND NOT WIN32)
    # Exporting link flag since it won't pass ament_export_libraries() existance check
    ament_export_link_flags("-latomic")
  endif()

  if(ament_cmake_cppcheck_FOUND)
    ament_cppcheck(
      TESTNAME "cppcheck_logging_macros"
      "${CMAKE_CURRENT_BINARY_DIR}/include/rcutils/logging_macros.h")
  endif()
  if(ament_cmake_cpplint_FOUND)
    ament_cpplint(
      TESTNAME "cpplint_logging_macros"
      # the generated code might contain longer lines for templated types
      MAX_LINE_LENGTH 999
      ROOT "${CMAKE_CURRENT_BINARY_DIR}/include"
      "${CMAKE_CURRENT_BINARY_DIR}/include/rcutils/logging_macros.h")
  endif()
  if(ament_cmake_uncrustify_FOUND)
    ament_uncrustify(
      TESTNAME "uncrustify_logging_macros"
      # the generated code might contain longer lines for templated types
      MAX_LINE_LENGTH 0
      "${CMAKE_CURRENT_BINARY_DIR}/include/rcutils/logging_macros.h")
  endif()

  find_package(mimick_vendor REQUIRED)

  find_package(osrf_testing_tools_cpp REQUIRED)
  get_target_property(memory_tools_test_env_vars
    osrf_testing_tools_cpp::memory_tools LIBRARY_PRELOAD_ENVIRONMENT_VARIABLE)
  get_target_property(memory_tools_is_available
    osrf_testing_tools_cpp::memory_tools LIBRARY_PRELOAD_ENVIRONMENT_IS_AVAILABLE)

  ament_add_gtest(test_logging test/test_logging.cpp)
  target_link_libraries(test_logging ${PROJECT_NAME} mimick osrf_testing_tools_cpp::memory_tools)

  add_executable(test_logging_long_messages test/test_logging_long_messages.cpp)
  target_link_libraries(test_logging_long_messages ${PROJECT_NAME})
  add_launch_test(
    "test/test_logging_long_messages.py"
    TARGET test_logging_long_messages
    WORKING_DIRECTORY "$<TARGET_FILE_DIR:test_logging_long_messages>"
    TIMEOUT 10
  )

  add_launch_test(
    "test/test_logging_output_format.py"
    TARGET test_logging_output_format
    WORKING_DIRECTORY "$<TARGET_FILE_DIR:test_logging_long_messages>"
    TIMEOUT 10
  )

  ament_add_gmock(test_logging_macros test/test_logging_macros.cpp)
  target_link_libraries(test_logging_macros ${PROJECT_NAME})

  add_executable(test_logging_macros_c test/test_logging_macros.c)
  target_link_libraries(test_logging_macros_c ${PROJECT_NAME})
  ament_add_test(test_logging_macros_c
    COMMAND "$<TARGET_FILE:test_logging_macros_c>"
    GENERATE_RESULT_FOR_RETURN_CODE_ZERO)

  set(SKIP_MEMORY_TOOLS_TEST "")
  if(NOT memory_tools_is_available)
    set(SKIP_MEMORY_TOOLS_TEST "SKIP_TEST")
  endif()

  macro(rcutils_custom_add_gtest target)
    ament_add_gtest(${target} ${ARGN})
  endmacro()

  macro(rcutils_custom_add_gmock target)
    ament_add_gmock(${target} ${ARGN})
  endmacro()

  # Gtests
  rcutils_custom_add_gtest(test_allocator test/test_allocator.cpp
    ENV ${memory_tools_test_env_vars}
    ${SKIP_MEMORY_TOOLS_TEST}
  )
  if(TARGET test_allocator)
    target_link_libraries(test_allocator ${PROJECT_NAME} osrf_testing_tools_cpp::memory_tools)
  endif()

  rcutils_custom_add_gtest(test_char_array
    test/test_char_array.cpp
  )
  if(TARGET test_char_array)
    target_link_libraries(test_char_array ${PROJECT_NAME} mimick)
  endif()

  # Can't use C++ with stdatomic_helper.h
  add_executable(test_atomics_executable
    test/test_atomics.c
  )
  set_target_properties(test_atomics_executable
    PROPERTIES
      LANGUAGE C
  )
  target_link_libraries(test_atomics_executable ${PROJECT_NAME})
  if(HAVE_LIBATOMICS)
    target_link_libraries(test_atomics_executable atomic)
  endif()

  add_test(NAME test_atomics COMMAND test_atomics_executable)

  rcutils_custom_add_gmock(test_error_handling test/test_error_handling.cpp
    # Append the directory of librcutils so it is found at test time.
    APPEND_LIBRARY_DIRS "$<TARGET_FILE_DIR:${PROJECT_NAME}>"
    ENV ${memory_tools_test_env_vars}
  )
  if(TARGET test_error_handling)
    target_link_libraries(test_error_handling ${PROJECT_NAME} osrf_testing_tools_cpp::memory_tools)
  endif()

  rcutils_custom_add_gmock(test_error_handling_helpers test/test_error_handling_helpers.cpp
    # Append the directory of librcutils so it is found at test time.
    APPEND_LIBRARY_DIRS "$<TARGET_FILE_DIR:${PROJECT_NAME}>"
    ENV ${memory_tools_test_env_vars}
  )
  if(TARGET test_error_handling_helpers)
    target_include_directories(test_error_handling_helpers PUBLIC include)
    target_link_libraries(test_error_handling_helpers osrf_testing_tools_cpp::memory_tools)
  endif()

  rcutils_custom_add_gtest(test_split
    test/test_split.cpp
  )
  if(TARGET test_split)
    target_link_libraries(test_split ${PROJECT_NAME} mimick)
  endif()

  rcutils_custom_add_gtest(test_find
    test/test_find.cpp
  )
  if(TARGET test_find)
    target_link_libraries(test_find ${PROJECT_NAME})
  endif()

  rcutils_custom_add_gtest(test_strerror
    test/test_strerror.cpp
  )
  if(TARGET test_strerror)
    target_link_libraries(test_strerror ${PROJECT_NAME} mimick)
  endif()

  rcutils_custom_add_gtest(test_string_array
    test/test_string_array.cpp
  )
  if(TARGET test_string_array)
    target_link_libraries(test_string_array ${PROJECT_NAME})
  endif()

  rcutils_custom_add_gtest(test_env test/test_env.cpp
    ENV
      EMPTY_TEST=
      NORMAL_TEST=foo
    APPEND_LIBRARY_DIRS "$<TARGET_FILE_DIR:${PROJECT_NAME}>"
  )
  if(TARGET test_env)
    target_link_libraries(test_env ${PROJECT_NAME})
  endif()

  rcutils_custom_add_gtest(test_filesystem
    test/test_filesystem.cpp
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
  )
  if(TARGET test_filesystem)
    ament_target_dependencies(test_filesystem "osrf_testing_tools_cpp")
    target_link_libraries(test_filesystem ${PROJECT_NAME} mimick)
    target_compile_definitions(test_filesystem PRIVATE BUILD_DIR="${CMAKE_CURRENT_BINARY_DIR}")
  endif()

  rcutils_custom_add_gtest(test_strdup
    test/test_strdup.cpp
  )
  if(TARGET test_strdup)
    target_link_libraries(test_strdup ${PROJECT_NAME})
  endif()

  rcutils_custom_add_gtest(test_format_string
    test/test_format_string.cpp
  )
  if(TARGET test_format_string)
    target_link_libraries(test_format_string ${PROJECT_NAME} mimick)
  endif()

  rcutils_custom_add_gtest(test_string_map
    test/test_string_map.cpp
  )
  if(TARGET test_string_map)
    ament_target_dependencies(test_string_map "osrf_testing_tools_cpp")
    target_link_libraries(test_string_map ${PROJECT_NAME})
  endif()

  rcutils_custom_add_gtest(test_isalnum_no_locale
    test/test_isalnum_no_locale.cpp
  )
  if(TARGET test_isalnum_no_locale)
    target_link_libraries(test_isalnum_no_locale ${PROJECT_NAME})
  endif()

  rcutils_custom_add_gtest(test_repl_str
    test/test_repl_str.cpp
  )
  if(TARGET test_repl_str)
    target_link_libraries(test_repl_str ${PROJECT_NAME})
  endif()

  macro(add_dummy_shared_library target)
    add_library(${target} test/dummy_shared_library/dummy_shared_library.c)
    if(WIN32)
      # Causes the visibility macros to use dllexport rather than dllimport
      # which is appropriate when building the dll but not consuming it.
      target_compile_definitions(${target} PRIVATE "DUMMY_SHARED_LIBRARY_BUILDING_DLL")
    endif()
  endmacro()

  ament_add_gtest(test_shared_library_in_run_paths test/test_shared_library.cpp)
  if(TARGET test_shared_library_in_run_paths)
    # Rely on CMake setting build tree RUNPATHs by default on Unix systems.
    add_dummy_shared_library(dummy_shared_library_in_run_paths)

=== debian/changelog ===
ros2-rcutils (5.2.0-7) unstable; urgency=medium

  * Source only upload
  * Remove old d/README.source
  * Fix date in d/copyright

 -- Jochen Sprickerhof <jspricke@debian.org>  Fri, 17 Jun 2022 15:17:30 +0200

ros2-rcutils (5.2.0-6) unstable; urgency=medium

  * Extend d/copyright

 -- Jochen Sprickerhof <jspricke@debian.org>  Wed, 15 Jun 2022 08:50:51 +0200

ros2-rcutils (5.2.0-5) unstable; urgency=medium

  * Add python3-rcutils package

 -- Jochen Sprickerhof <jspricke@debian.org>  Mon, 13 Jun 2022 22:14:45 +0200

ros2-rcutils (5.2.0-4) unstable; urgency=medium

  * Team upload.

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Set field Upstream-Name in debian/copyright.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Jochen Sprickerhof ]
  * Add patch for ROS 1 compatibility
  * Bump policy version (no changes)
  * Drop versioned dependencies

 -- Jochen Sprickerhof <jspricke@debian.org>  Thu, 02 Jun 2022 21:48:06 +0200

ros2-rcutils (5.2.0-3) unstable; urgency=medium

  * Move libatomic test out of BUILD_TESTING conditional block

 -- Timo Röhling <roehling@debian.org>  Mon, 16 May 2022 11:41:08 +0200

ros2-rcutils (5.2.0-2) unstable; urgency=medium

  * Stop generating cruft files

 -- Timo Röhling <roehling@debian.org>  Sun, 15 May 2022 16:19:54 +0200

ros2-rcutils (5.2.0-1) unstable; urgency=medium

  * Initial release (Closes: #1010779)

 -- Timo Röhling <roehling@debian.org>  Tue, 10 May 2022 15:56:02 +0200

=== debian/control ===
Source: ros2-rcutils
Section: libs
Priority: optional
Maintainer: Debian Robotics Team <team+robotics@tracker.debian.org>
Uploaders: Timo Röhling <roehling@debian.org>, Jochen Sprickerhof <jspricke@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 ament-cmake-python,
 ament-cmake-ros,
 cmake,
 dh-ros,
 dh-sequence-python3,
 python3-empy,
Homepage: https://github.com/ros2/rcutils
Standards-Version: 4.6.1
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/robotics-team/ros2-rcutils.git
Vcs-Browser: https://salsa.debian.org/robotics-team/ros2-rcutils
Description: C Utilities and Data Structures for ROS 2
 This package is part of ROS 2, the Robot Operating System.
 It provides basic macros, functions, and data structures for the ROS 2
 codebase.

Package: librcutils0d
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package installs the shared library.

Package: librcutils-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 librcutils0d (= ${binary:Version}),
Description: ${source:Synopsis} (development headers)
 ${source:Extended-Description}
 .
 This package installs the C headers and CMake config files.

Package: python3-rcutils
Section: python
Architecture: all
Depends:
 ${misc:Depends},
 ${python3:Depends},
Description: ${source:Synopsis} (Python 3 library)
 ${source:Extended-Description}
 .
 This package installs the Python 3 library.

=== debian/rules ===
#!/usr/bin/make -f

export ROS_CONFIGURE_ARGS = -DBUILD_TESTING=OFF -DRCUTILS_SOVERSION=0d

%:
	dh $@ --buildsystem=ros

=== debian/watch ===
version=4
opts=filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1% \
 https://github.com/ros2/rcutils/tags (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## ros2-rcutils 6.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -226,16 +226,8 @@
     set(SKIP_MEMORY_TOOLS_TEST "SKIP_TEST")
   endif()
 
-  macro(rcutils_custom_add_gtest target)
-    ament_add_gtest(${target} ${ARGN})
-  endmacro()
-
-  macro(rcutils_custom_add_gmock target)
-    ament_add_gmock(${target} ${ARGN})
-  endmacro()
-
   # Gtests
-  rcutils_custom_add_gtest(test_allocator test/test_allocator.cpp
+  ament_add_gtest(test_allocator test/test_allocator.cpp
     ENV ${memory_tools_test_env_vars}
     ${SKIP_MEMORY_TOOLS_TEST}
   )
@@ -243,7 +235,7 @@
     target_link_libraries(test_allocator ${PROJECT_NAME} osrf_testing_tools_cpp::memory_tools)
   endif()
 
-  rcutils_custom_add_gtest(test_char_array
+  ament_add_gtest(test_char_array
     test/test_char_array.cpp
   )
   if(TARGET test_char_array)
@@ -265,7 +257,7 @@
 
   add_test(NAME test_atomics COMMAND test_atomics_executable)
 
-  rcutils_custom_add_gmock(test_error_handling test/test_error_handling.cpp
+  ament_add_gmock(test_error_handling test/test_error_handling.cpp
     # Append the directory of librcutils so it is found at test time.
     APPEND_LIBRARY_DIRS "$<TARGET_FILE_DIR:${PROJECT_NAME}>"
     ENV ${memory_tools_test_env_vars}
@@ -274,7 +266,7 @@
     target_link_libraries(test_error_handling ${PROJECT_NAME} osrf_testing_tools_cpp::memory_tools)
   endif()
 
-  rcutils_custom_add_gmock(test_error_handling_helpers test/test_error_handling_helpers.cpp
+  ament_add_gmock(test_error_handling_helpers test/test_error_handling_helpers.cpp
     # Append the directory of librcutils so it is found at test time.
     APPEND_LIBRARY_DIRS "$<TARGET_FILE_DIR:${PROJECT_NAME}>"
     ENV ${memory_tools_test_env_vars}
@@ -284,35 +276,35 @@
     target_link_libraries(test_error_handling_helpers osrf_testing_tools_cpp::memory_tools)
   endif()
 
-  rcutils_custom_add_gtest(test_split
+  ament_add_gtest(test_split
     test/test_split.cpp
   )
   if(TARGET test_split)
     target_link_libraries(test_split ${PROJECT_NAME} mimick)
   endif()
 
-  rcutils_custom_add_gtest(test_find
+  ament_add_gtest(test_find
     test/test_find.cpp
   )
   if(TARGET test_find)
     target_link_libraries(test_find ${PROJECT_NAME})
   endif()
 
-  rcutils_custom_add_gtest(test_strerror
+  ament_add_gtest(test_strerror
     test/test_strerror.cpp
   )
   if(TARGET test_strerror)
     target_link_libraries(test_strerror ${PROJECT_NAME} mimick)
   endif()
 
-  rcutils_custom_add_gtest(test_string_array
+  ament_add_gtest(test_string_array
     test/test_string_array.cpp
   )
   if(TARGET test_string_array)
     target_link_libraries(test_string_array ${PROJECT_NAME})
   endif()
 
-  rcutils_custom_add_gtest(test_env test/test_env.cpp
+  ament_add_gtest(test_env test/test_env.cpp
     ENV
       EMPTY_TEST=
       NORMAL_TEST=foo
@@ -322,7 +314,7 @@
     target_link_libraries(test_env ${PROJECT_NAME})
   endif()
 
-  rcutils_custom_add_gtest(test_filesystem
+  ament_add_gtest(test_filesystem
     test/test_filesystem.cpp
     WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
   )
@@ -332,21 +324,21 @@
     target_compile_definitions(test_filesystem PRIVATE BUILD_DIR="${CMAKE_CURRENT_BINARY_DIR}")
   endif()
 
-  rcutils_custom_add_gtest(test_strdup
+  ament_add_gtest(test_strdup
     test/test_strdup.cpp
   )
   if(TARGET test_strdup)
     target_link_libraries(test_strdup ${PROJECT_NAME})
   endif()
 
-  rcutils_custom_add_gtest(test_format_string
+  ament_add_gtest(test_format_string
     test/test_format_string.cpp
   )
   if(TARGET test_format_string)
     target_link_libraries(test_format_string ${PROJECT_NAME} mimick)
   endif()
 
-  rcutils_custom_add_gtest(test_string_map
+  ament_add_gtest(test_string_map
     test/test_string_map.cpp
   )
   if(TARGET test_string_map)
@@ -354,14 +346,14 @@
     target_link_libraries(test_string_map ${PROJECT_NAME})
   endif()
 
-  rcutils_custom_add_gtest(test_isalnum_no_locale
+  ament_add_gtest(test_isalnum_no_locale
     test/test_isalnum_no_locale.cpp
   )
   if(TARGET test_isalnum_no_locale)
     target_link_libraries(test_isalnum_no_locale ${PROJECT_NAME})
   endif()
 
-  rcutils_custom_add_gtest(test_repl_str
+  ament_add_gtest(test_repl_str
     test/test_repl_str.cpp
   )
   if(TARGET test_repl_str)
@@ -381,3 +373,7 @@
   if(TARGET test_shared_library_in_run_paths)
     # Rely on CMake setting build tree RUNPATHs by default on Unix systems.
     add_dummy_shared_library(dummy_shared_library_in_run_paths)
+    target_compile_definitions(test_shared_library_in_run_paths PRIVATE
+      "SHARED_LIBRARY_UNDER_TEST=dummy_shared_library_in_run_paths")
+    if(NOT WIN32 AND NOT APPLE)
+      # NOTE(hidmic): DT_RUNPATH entries are ignored by dlopen in Linux despite the fact

=== debian/changelog ===
ros2-rcutils (6.0.1-1) unstable; urgency=medium

  * New upstream version 6.0.1

 -- Jochen Sprickerhof <jspricke@debian.org>  Thu, 03 Nov 2022 17:37:30 +0100

ros2-rcutils (6.0.0-2) unstable; urgency=medium

  * Upload to unstable.
  * Switch to Github API for d/watch

 -- Timo Röhling <roehling@debian.org>  Sun, 02 Oct 2022 16:02:32 +0200

ros2-rcutils (6.0.0-1) experimental; urgency=medium

  * New upstream version 6.0.0
  * Bump SOVERSION to 1d
  * Enable hardening flags

 -- Timo Röhling <roehling@debian.org>  Sat, 17 Sep 2022 21:00:48 +0200

=== debian/control ===
--- 
+++ 
@@ -21,7 +21,7 @@
  It provides basic macros, functions, and data structures for the ROS 2
  codebase.
 
-Package: librcutils0d
+Package: librcutils1d
 Architecture: any
 Multi-Arch: same
 Depends:
@@ -38,7 +38,7 @@
 Multi-Arch: same
 Depends:
  ${misc:Depends},
- librcutils0d (= ${binary:Version}),
+ librcutils1d (= ${binary:Version}),
 Description: ${source:Synopsis} (development headers)
  ${source:Extended-Description}
  .

=== debian/watch ===
version=4
opts=searchmode=plain,filenamemangle=s%(?:.*?/)?v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz% \
 https://api.github.com/repos/ros2/rcutils/tags \
 tarball/(?:[^"]*?/)?v?@ANY_VERSION@

## ros2-rcutils 6.3.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -6,9 +6,9 @@
 if(NOT CMAKE_C_STANDARD)
   set(CMAKE_C_STANDARD 11)
 endif()
-# Default to C++14
+# Default to C++17
 if(NOT CMAKE_CXX_STANDARD)
-  set(CMAKE_CXX_STANDARD 14)
+  set(CMAKE_CXX_STANDARD 17)
 endif()
 
 include(CheckLibraryExists)
@@ -63,6 +63,7 @@
   src/process.c
   src/qsort.c
   src/repl_str.c
+  src/sha256.c
   src/shared_library.c
   src/snprintf.c
   src/split.c
@@ -143,16 +144,18 @@
   RUNTIME DESTINATION bin)
 
 if(BUILD_TESTING)
-  if(NOT WIN32)
-    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++14")
-  endif()
-
   find_package(performance_test_fixture REQUIRED)
 
   find_package(ament_cmake_gmock REQUIRED)
   find_package(ament_cmake_gtest REQUIRED)
   find_package(ament_cmake_pytest REQUIRED)
   find_package(ament_lint_auto REQUIRED)
+  # cppcheck 1.90 doesn't understand some of the syntax in remove_noexcept.hpp
+  # Since we already have cppcheck disabled on Linux, just disable it completely
+  # for this package.
+  list(APPEND AMENT_LINT_AUTO_EXCLUDE
+    ament_cmake_cppcheck
+  )
   ament_lint_auto_find_test_dependencies()
 
   find_package(launch_testing_ament_cmake REQUIRED)
@@ -358,6 +361,13 @@
   )
   if(TARGET test_repl_str)
     target_link_libraries(test_repl_str ${PROJECT_NAME})
+  endif()
+
+  ament_add_gtest(test_sha256
+    test/test_sha256.cpp
+  )
+  if(TARGET test_sha256)
+    target_link_libraries(test_sha256 ${PROJECT_NAME})
   endif()
 
   macro(add_dummy_shared_library target)
@@ -373,7 +383,3 @@
   if(TARGET test_shared_library_in_run_paths)
     # Rely on CMake setting build tree RUNPATHs by default on Unix systems.
     add_dummy_shared_library(dummy_shared_library_in_run_paths)
-    target_compile_definitions(test_shared_library_in_run_paths PRIVATE
-      "SHARED_LIBRARY_UNDER_TEST=dummy_shared_library_in_run_paths")
-    if(NOT WIN32 AND NOT APPLE)
-      # NOTE(hidmic): DT_RUNPATH entries are ignored by dlopen in Linux despite the fact

=== debian/changelog ===
ros2-rcutils (6.3.0-1) unstable; urgency=medium

  * New upstream version 6.3.0
  * Refresh patches
  * Update symbols
  * Bump Standards-Version to 4.6.2

 -- Timo Röhling <roehling@debian.org>  Tue, 27 Jun 2023 23:24:19 +0200

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
  dh-sequence-python3,
  python3-empy,
 Homepage: https://github.com/ros2/rcutils
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/robotics-team/ros2-rcutils.git
 Vcs-Browser: https://salsa.debian.org/robotics-team/ros2-rcutils

## ros2-rcutils 6.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -322,8 +322,7 @@
     WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
   )
   if(TARGET test_filesystem)
-    ament_target_dependencies(test_filesystem "osrf_testing_tools_cpp")
-    target_link_libraries(test_filesystem ${PROJECT_NAME} mimick)
+    target_link_libraries(test_filesystem ${PROJECT_NAME} mimick osrf_testing_tools_cpp::memory_tools)
     target_compile_definitions(test_filesystem PRIVATE BUILD_DIR="${CMAKE_CURRENT_BINARY_DIR}")
   endif()
 
@@ -345,8 +344,7 @@
     test/test_string_map.cpp
   )
   if(TARGET test_string_map)
-    ament_target_dependencies(test_string_map "osrf_testing_tools_cpp")
-    target_link_libraries(test_string_map ${PROJECT_NAME})
+    target_link_libraries(test_string_map ${PROJECT_NAME} osrf_testing_tools_cpp::memory_tools)
   endif()
 
   ament_add_gtest(test_isalnum_no_locale
@@ -383,3 +381,4 @@
   if(TARGET test_shared_library_in_run_paths)
     # Rely on CMake setting build tree RUNPATHs by default on Unix systems.
     add_dummy_shared_library(dummy_shared_library_in_run_paths)
+    target_compile_definitions(test_shared_library_in_run_paths PRIVATE

=== debian/changelog ===
ros2-rcutils (6.5.0-1) unstable; urgency=medium

  * New upstream version 6.5.0
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Thu, 04 Jan 2024 12:46:33 +0100

ros2-rcutils (6.4.1-1) unstable; urgency=medium

  * New upstream version 6.4.1

 -- Timo Röhling <roehling@debian.org>  Sun, 12 Nov 2023 22:04:35 +0100

ros2-rcutils (6.4.0-1) unstable; urgency=medium

  * New upstream version 6.4.0

 -- Timo Röhling <roehling@debian.org>  Thu, 26 Oct 2023 11:41:06 +0200

ros2-rcutils (6.3.1-1) unstable; urgency=medium

  * New upstream version 6.3.1

 -- Timo Röhling <roehling@debian.org>  Thu, 14 Sep 2023 14:15:22 +0200

## ros2-rcutils 6.9.3

=== debian/changelog ===
ros2-rcutils (6.9.3-1) unstable; urgency=medium

  * Update d/watch to latest GitHub recipe
  * New upstream version 6.9.3

 -- Timo Röhling <roehling@debian.org>  Thu, 10 Oct 2024 15:02:59 +0200

ros2-rcutils (6.9.2-1) unstable; urgency=medium

  * New upstream version 6.9.2
  * Wrap and sort Debian package files
  * New rcutils_set_env_overwrite symbol

 -- Timo Röhling <roehling@debian.org>  Wed, 25 Sep 2024 17:48:55 +0200

ros2-rcutils (6.9.1-1) unstable; urgency=medium

  * New upstream version 6.9.1

 -- Timo Röhling <roehling@debian.org>  Tue, 03 Sep 2024 16:43:29 +0200

ros2-rcutils (6.9.0-1) unstable; urgency=medium

  * New upstream version 6.9.0
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Fri, 12 Jul 2024 18:17:12 +0200

ros2-rcutils (6.8.0-1) unstable; urgency=medium

  * New upstream version 6.8.0
  * Refresh patches (no functional changes)
  * Update d/copyright

 -- Timo Röhling <roehling@debian.org>  Sun, 28 Apr 2024 23:51:12 +0200

ros2-rcutils (6.7.0-1) unstable; urgency=medium

  * New upstream version 6.7.0

 -- Timo Röhling <roehling@debian.org>  Sat, 20 Apr 2024 00:01:29 +0200

ros2-rcutils (6.6.0-1) unstable; urgency=medium

  * New upstream version 6.6.0
  * Refresh patches (no functional changes)
  * Bump Standards-Version to 4.7.0
  * Update d/symbols

 -- Timo Röhling <roehling@debian.org>  Wed, 10 Apr 2024 22:13:41 +0200

## ros2-rcutils 6.9.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.12)
+cmake_minimum_required(VERSION 3.20)
 
 project(rcutils)
 
@@ -15,6 +15,21 @@
 
 find_package(ament_cmake_python REQUIRED)
 find_package(ament_cmake_ros REQUIRED)
+
+# By default, without the settings below, find_package(Python3) will attempt
+# to find the newest python version it can, and additionally will find the
+# most specific version.  For instance, on a system that has
+# /usr/bin/python3.10, /usr/bin/python3.11, and /usr/bin/python3, it will find
+# /usr/bin/python3.11, even if /usr/bin/python3 points to /usr/bin/python3.10.
+# The behavior we want is to prefer the "system" installed version unless the
+# user specifically tells us othewise through the Python3_EXECUTABLE hint.
+# Setting CMP0094 to NEW means that the search will stop after the first
+# python version is found.  Setting Python3_FIND_UNVERSIONED_NAMES means that
+# the search will prefer /usr/bin/python3 over /usr/bin/python3.11.  And that
+# latter functionality is only available in CMake 3.20 or later, so we need
+# at least that version.
+cmake_policy(SET CMP0094 NEW)
+set(Python3_FIND_UNVERSIONED_NAMES FIRST)
 
 find_package(Python3 REQUIRED COMPONENTS Interpreter)
 
@@ -197,7 +212,7 @@
     osrf_testing_tools_cpp::memory_tools LIBRARY_PRELOAD_ENVIRONMENT_IS_AVAILABLE)
 
   ament_add_gtest(test_logging test/test_logging.cpp)
-  target_link_libraries(test_logging ${PROJECT_NAME} mimick osrf_testing_tools_cpp::memory_tools)
+  target_link_libraries(test_logging ${PROJECT_NAME} osrf_testing_tools_cpp::memory_tools)
 
   add_executable(test_logging_long_messages test/test_logging_long_messages.cpp)
   target_link_libraries(test_logging_long_messages ${PROJECT_NAME})
@@ -242,7 +257,7 @@
     test/test_char_array.cpp
   )
   if(TARGET test_char_array)
-    target_link_libraries(test_char_array ${PROJECT_NAME} mimick)
+    target_link_libraries(test_char_array ${PROJECT_NAME})
   endif()
 
   # Can't use C++ with stdatomic_helper.h
@@ -283,7 +298,7 @@
     test/test_split.cpp
   )
   if(TARGET test_split)
-    target_link_libraries(test_split ${PROJECT_NAME} mimick)
+    target_link_libraries(test_split ${PROJECT_NAME})
   endif()
 
   ament_add_gtest(test_find
@@ -296,6 +311,7 @@
   ament_add_gtest(test_strerror
     test/test_strerror.cpp
   )
+  ament_add_test_label(test_strerror mimick)
   if(TARGET test_strerror)
     target_link_libraries(test_strerror ${PROJECT_NAME} mimick)
   endif()
@@ -321,6 +337,7 @@
     test/test_filesystem.cpp
     WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
   )
+  ament_add_test_label(test_filesystem mimick)
   if(TARGET test_filesystem)
     target_link_libraries(test_filesystem ${PROJECT_NAME} mimick osrf_testing_tools_cpp::memory_tools)
     target_compile_definitions(test_filesystem PRIVATE BUILD_DIR="${CMAKE_CURRENT_BINARY_DIR}")
@@ -337,7 +354,7 @@
     test/test_format_string.cpp
   )
   if(TARGET test_format_string)
-    target_link_libraries(test_format_string ${PROJECT_NAME} mimick)
+    target_link_libraries(test_format_string ${PROJECT_NAME})
   endif()
 
   ament_add_gtest(test_string_map
@@ -355,30 +372,3 @@
   endif()
 
   ament_add_gtest(test_repl_str
-    test/test_repl_str.cpp
-  )
-  if(TARGET test_repl_str)
-    target_link_libraries(test_repl_str ${PROJECT_NAME})
-  endif()
-
-  ament_add_gtest(test_sha256
-    test/test_sha256.cpp
-  )
-  if(TARGET test_sha256)
-    target_link_libraries(test_sha256 ${PROJECT_NAME})
-  endif()
-
-  macro(add_dummy_shared_library target)
-    add_library(${target} test/dummy_shared_library/dummy_shared_library.c)
-    if(WIN32)
-      # Causes the visibility macros to use dllexport rather than dllimport
-      # which is appropriate when building the dll but not consuming it.
-      target_compile_definitions(${target} PRIVATE "DUMMY_SHARED_LIBRARY_BUILDING_DLL")
-    endif()
-  endmacro()
-
-  ament_add_gtest(test_shared_library_in_run_paths test/test_shared_library.cpp)
-  if(TARGET test_shared_library_in_run_paths)
-    # Rely on CMake setting build tree RUNPATHs by default on Unix systems.
-    add_dummy_shared_library(dummy_shared_library_in_run_paths)
-    target_compile_definitions(test_shared_library_in_run_paths PRIVATE

=== debian/changelog ===
ros2-rcutils (6.9.4-1) unstable; urgency=medium

  * New upstream version 6.9.4
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Sun, 16 Feb 2025 14:07:38 +0100

=== debian/control ===
--- 
+++ 
@@ -2,17 +2,19 @@
 Section: libs
 Priority: optional
 Maintainer: Debian Robotics Team <team+robotics@tracker.debian.org>
-Uploaders: Timo Röhling <roehling@debian.org>, Jochen Sprickerhof <jspricke@debian.org>
+Uploaders:
+ Timo Röhling <roehling@debian.org>,
+ Jochen Sprickerhof <jspricke@debian.org>,
 Build-Depends:
- debhelper-compat (= 13),
  ament-cmake-python,
  ament-cmake-ros,
  cmake,
+ debhelper-compat (= 13),
  dh-ros,
  dh-sequence-python3,
  python3-empy,
 Homepage: https://github.com/ros2/rcutils
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/robotics-team/ros2-rcutils.git
 Vcs-Browser: https://salsa.debian.org/robotics-team/ros2-rcutils
@@ -37,8 +39,8 @@
 Architecture: any
 Multi-Arch: same
 Depends:
+ librcutils1d (= ${binary:Version}),
  ${misc:Depends},
- librcutils1d (= ${binary:Version}),
 Description: ${source:Synopsis} (development headers)
  ${source:Extended-Description}
  .

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export ROS_CONFIGURE_ARGS = -DBUILD_TESTING=OFF -DRCUTILS_SOVERSION=1d

%:
	dh $@ --buildsystem=ros

=== debian/watch ===
version=4
opts=\
 filenamemangle=s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,\
 downloadurlmangle=s%(api.github.com/repos/[^/]+/[^/]+)/git/refs/%$1/tarball/refs/%g,\
 searchmode=plain \
 https://api.github.com/repos/ros2/rcutils/git/matching-refs/tags/ \
 https://api.github.com/repos/[^/]+/[^/]+/git/refs/tags/@ANY_VERSION@
